{ <Punkt in ...>

  Copyright (C) <2020> <Bernd Hübner>

  This library is free software; you can redistribute it and/or modify it under the
  terms of the GNU Library General Public License as published by the Free Software
  Foundation; either version 2 of the License, or (at your option) any later
  version with the following modification:

  As a special exception, the copyright holders of this library give you permission
  to link this library with independent modules to produce an executable,
  regardless of the license terms of these independent modules,and to copy and
  distribute the resulting executable under terms of your choice, provided that you
  also meet, for each linked independent module, the terms and conditions of the
  license of that module. An independent module is a module which is not derived
  from or based on this library. If you modify this library, you may extend this
  exception to your version of the library, but you are not obligated to do so. If
  you do not wish to do so, delete this exception statement from your version.

  This program is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE. See the GNU Library General Public License for more details.

  You should have received a copy of the GNU Library General Public License along
  with this library; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street - Fifth Floor, Boston, MA 02110-1335, USA.
}


unit ptin;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Types, Math;

function PointInCircle(aRect:TRect;x,y:integer) : boolean;
function PointInRoundRect(aRect:TRect;x,y,rx,ry:integer):boolean;
function PointInEllipse(aRect:TRect;x,y:integer):boolean;
function PtInPoly(const points: array of TPoint;var p: TPoint): Boolean;

implementation

function PointInCircle(aRect:TRect;x,y:integer) : boolean;
var radius     : integer;
    hypotenuse : integer;
    a,b        : integer;
begin
 radius := (aRect.Right - aRect.Left) div 2;
 a := aRect.CenterPoint.X - x;
 b := aRect.CenterPoint.Y - y;
 hypotenuse := round(sqrt(sqr(a) + sqr(b)));
 if hypotenuse <= radius then result:= true else result := false;
end;

function PointInRoundRect(aRect:TRect;x,y,rx,ry:integer):boolean;
//funktioniert bis rx<=aRect.width,ry<=aRect.height !!!
var checkRect : TRect;
    checkP    : TPoint;

procedure Check;
begin
 result:= true;
 exit;
end;

begin
 result:=false;
 checkP.X:=x;checkP.Y:=y;
 checkRect := rect(aRect.Left+(rx div 2),aRect.Top,aRect.Right-(rx div 2),aRect.Bottom);
 if PtInRect(checkRect,checkP) then Check;
 checkRect := rect(aRect.Left,aRect.Top+(ry div 2),aRect.Right,aRect.Bottom-(ry div 2));
 if PtInRect(checkRect,checkP) then Check;
//prüfe links oben
 checkRect := rect(aRect.Left,aRect.Top,aRect.Left+(aRect.Width div 2),aRect.Top+(aRect.Height div 2));
 if PtInRect(checkRect,checkP) then
  begin
   checkRect := rect(aRect.Left,aRect.Top,aRect.Left+rx,aRect.Top+ry);//Top+ry);
   if PointInEllipse(checkRect,x,y) then Check;
 end;

 //prüfe rechts oben
  checkRect := rect(aRect.Right-(aRect.Width div 2),aRect.Top,aRect.Right,aRect.Top+(aRect.Height div 2));
  if PtInRect(checkRect,checkP) then
   begin
    checkRect := rect(aRect.Right-rx,aRect.Top,aRect.Right,aRect.Top+ry);
    if PointInEllipse(checkRect,x,y) then Check;
  end;
 //prüfe links unten
  checkRect := rect(aRect.Left,aRect.Top+(aRect.Height div 2),aRect.Left+(aRect.Width div 2),aRect.Bottom);
  if PtInRect(checkRect,checkP) then
   begin
    checkRect := rect(aRect.Left,aRect.Bottom-ry,aRect.Left+rx,aRect.Bottom);
    if PointInEllipse(checkRect,x,y) then Check;
  end;
 //prüfe rechts unten
  checkRect := rect(aRect.Left+(aRect.Width div 2),aRect.Top+(aRect.Height div 2),aRect.Right,aRect.Bottom);
  if PtInRect(checkRect,checkP) then
   begin
    checkRect := rect(aRect.Right-rx,aRect.Bottom-ry,aRect.Right,aRect.Bottom);
    if PointInEllipse(checkRect,x,y) then Check;
  end;

end;

function PointInEllipse(aRect:TRect;x,y:integer):boolean;
var rx,ry,res1,res2 : double;
begin
 rx:= aRect.Width / 2;
 ry:= aRect.Height / 2;
 res1:= (sqr(x-aRect.CenterPoint.X)) / (sqr(rx));
 res2:= (sqr(y-aRect.CenterPoint.Y)) / (sqr(ry));
 res1:=res1+res2;
 if res1 <= 1 then result:= true else result:=false;
end;

function PtInPoly(const points: array of TPoint;var p: TPoint): Boolean;
var
  i     : Integer;
  angle : Double;
  InIt  : boolean;
  p1,p2 : TPoint;

  function Angle2D(x1, y1, x2, y2: Double): Double;
  var
    dtheta, theta1, theta2: Double;
  begin
    theta1 := ArcTan2(y1, x1);
    theta2 := ArcTan2(y2, x2);
    dtheta := theta2 - theta1;
    while (dtheta > PI) do
       dtheta := dtheta - 2*pi;
    while (dtheta < -PI) do
       dtheta := dtheta + 2*pi;
    result := dtheta;
  end;

begin
  angle := 0;
  for i := 0 to High(points) do
  begin
    p1.X := points[i].X - p.X;
    p1.Y := points[i].Y - p.Y;
    p2.X := points[(i+1) mod Length(points)].X - p.X;
    p2.Y := points[(i+1) mod Length(points)].Y - p.Y;
    angle := angle + Angle2D(p1.X, p1.Y, p2.X, p2.Y);
  end;
  InIt := Abs(angle) < pi;
  if InIt then result:=false else result:=true;
end;


end.

